#include <iostream>
#include <vector>

int main() {
    std::cout << "Esempi di cicli for:" << std::endl;

    std::cout << "\n\n1) ciclo for standard con un solo statement nel body: \n";
    for (int i = 0; i < 10; ++i)
        std::cout << i << ' ';

    std::cout << "\n\n2) ciclo for senza body, con un operazione \ninclusa nell iteration_expression :\n";
    std::cout << " - ";
    for (int i = 0; i < 10; std::cout << i << " - ", ++i );

    std::cout << "\n\n3) nel init-statement si possono inzizializzare più valori\n";
    for (int i = 0, *p = &i; i < 9; i += 2)
        std::cout << i << ':' << *p << ' ';

    std::cout << "\n\n4) la condizione pù essere dichiarativa:\n";
    char cstr[] = "Hello";
    for (int n = 0; char c = cstr[n]; ++n)
        std::cout << c;

    std::cout << "\n\n5) init-statement può usare l'operatore auto :\n";
    std::vector<int> v = {3, 1, 4, 1, 5, 9};
    for (auto iter = v.begin(); iter != v.end(); ++iter)
        std::cout << *iter << ' ';

    std::cout << "\n\n6) init-statement può essere un espressione:\n";
    int n = 0;
    for (std::cout << "Loop start\n";
         std::cout << "Loop test\n";
         std::cout << "Iteration " << ++n << '\n')
    {
        if (n > 1)
            break;
    }

    std::cout << "\n7) Costruttori e distruttori di oggetti creati - distrutti\n"
                 "nel body sono chiamati a ogni iterazione:\n";
    struct S
    {
        S(int x, int y) { std::cout << "S::S(" << x << ", " << y << "); "; }
        ~S() { std::cout << "S::~S()\n"; }
    };

    for (int i{0}, j{5}; i < j; ++i, --j)
        S s{i, j};

    std::cout << std::endl;

    return 0;
}

